<?php
define('REMOTE_XML_URL_PREFIX', 'http://water.weather.gov/ahps2/hydrograph_to_xml.php?gage=');
define('REMOTE_XML_URL_SUFFIX', '&output=xml');

define('LOCAL_XML_URL_PREFIX',  '/home/titanicbush/public_html/river/data_cache/xml/');
define('LOCAL_XML_URL_SUFFIX',  '.xml');

define('LOCAL_JSON_PATH',       '/home/titanicbush/public_html/river/data_cache/');
define('LOCAL_JSON_FILENAME',   'gauges.json');

class endpointConfig {
	private $endpoints = array(
	"Fulton, IL"=>"flti2",
	"Camanche, IA"=>"cmmi4",
	"LeClaire, IA"=>"leci4",
	"Rock Island, IL"=>"rcki2",
	"Illinois City, IL"=>"ilni2",
	"Muscatine, IA"=>"musi4",
        "New Boston, IL"=>"nboi2",
	"Keithsburg, IL"=>"khbi2",
	"Gladstone, IL LD18"=>"gldi2",
    	"Burlington, IA"=>"brli4",
    	"Keokuk, IA LD19"=>"eoki4",
    	"Gregory Landing, MO"=>"ggym7",
    	"Canton, MO LD20"=>"canm7",
    	"Quincy, IL"=>"uini2",
    	"Quincy, IL LD21"=>"qldi2",
    	"Hannibal, MO"=>"hnnm7",
    	"Saverton, MO LD22"=>"svrm7",
    	"Louisiana, MO"=>"lusm7",
    	"Clarksville, MO LD24"=>"clkm7",
    	"Winfield, MO LD25"=>"cagm7",
    	"Grafton, IL"=>"grfi2",
    	"Alton, IL Mel Price"=>"alni2",
    	"St. Louis, MO"=>"eadm7"
  	);
	
	public function get_endpoint_urls() {
		$urls = array();
		foreach ($this->endpoints as $location => $id) {
			$urls[$location] = REMOTE_XML_URL_PREFIX . $id . REMOTE_XML_URL_SUFFIX;
		}
		return $urls;
	}

	public function get_local_copy_filenames() {
		$filenames = array();
		foreach ($this->endpoints as $location => $id) {
		        echo /*getcwd() . */LOCAL_XML_URL_PREFIX . $id . LOCAL_XML_URL_SUFFIX . "<br>";
			$filenames[$location] = /*getcwd() . */LOCAL_XML_URL_PREFIX . $id . LOCAL_XML_URL_SUFFIX;
		}
		return $filenames;
	}

	public function get_local_filename() {
	        echo "Json Filename: " /*. getcwd() */. LOCAL_JSON_PATH . LOCAL_JSON_FILENAME . "<br>";
		return /*getcwd() . */LOCAL_JSON_PATH . LOCAL_JSON_FILENAME;
	}
}

class endpointCopier {
	
	public function copy_endpoints($urls, $localCopies)
	{
		echo "<h2>Retrieving ...</h2><dl>";
		try {
			foreach ($urls as $location => $url) {
			echo "<dt>" . $url . "</dt>";
			echo "<dt>" . $localCopies[$location] . "</dt>";
				if (!copy($url, $localCopies[$location])) {
					echo("<dd>Failure</dd>");
				} else {
					echo("<dd>Success</dd>");
				}
			}
		} catch(Exception $e) {
			log('Caught exception: ', $e->getMessage());
		}
		echo "</dl>";
	}
}

class xmlGetObject {
	public function get($url) {
	    $fileContents = file_get_contents($url);
        $fileContents = str_replace(array("\n", "\r", "\t"), '', $fileContents);
        $fileContents = trim(str_replace('"', "'", $fileContents));
        $simpleXml 	  = simplexml_load_string($fileContents);
        return $simpleXml;
	}
}

class translateEndpoints {
	public function combine($sources) {
		$xml        = new xmlGetObject();
		$translated = array();
		$translated2 = array();

		foreach ($sources as $key => $value) {
		    $district = get_object_vars($xml->get($value))['@attributes']['originator'];
		    $translated[$key] = $xml->get($value);
		    $translated2[$district][$key] = $xml->get($value);
		}
		//echo(json_encode($translated2));
		
		return json_encode($translated);
	}
}

$config     = new endpointConfig();
$locals     = $config->get_local_copy_filenames();
$copy       = new endpointCopier();
$translator = new translateEndpoints();
//$xml    = new xmlGetObject($locals['Hannibal, MO']);

$copy->copy_endpoints($config->get_endpoint_urls(), $locals);
$translated = $translator->combine($locals);

$jsonFile = fopen($config->get_local_filename(), "w") or die("Unable to open file!");
fwrite($jsonFile, $translated);
fclose($jsonFile);

echo php_sapi_name();
echo date("F d Y H:i:s.", filemtime(getcwd() . LOCAL_XML_URL_PREFIX . 'alni2.xml'));
//print_r($translated);
//print_r(json_encode($xml->get($locals['Hannibal, MO'])));



//print_r($test->get_endpoint_urls());
?>
