<?php
define('LOCAL_KML_URL_PREFIX',  '/home/titanicbush/public_html/river/data_cache/kml/');
define('LOCAL_KML_URL_SUFFIX',  '.kml');

define('LOCAL_JSON_PATH',       '/river/data_cache/');	
define('LOCAL_JSON_FILENAME',   'gauges.json');

class endpointConfig {
	private $endpoints = array(
		"Day 1-2" => 'http://www.wpc.ncep.noaa.gov/kml/qpf/QPF48hr_Day1-2_latest.kml',
		"Day 1-3" => 'http://www.wpc.ncep.noaa.gov/kml/qpf/QPF72hr_Day1-3_latest.kml',
		"Day 4-5" => 'http://www.wpc.ncep.noaa.gov/kml/qpf/QPF48hr_Day4-5_latest.kml',
		"Day 6-7" => 'http://www.wpc.ncep.noaa.gov/kml/qpf/QPF48hr_Day6-7_latest.kml',
		"Day 1-5" => 'http://www.wpc.ncep.noaa.gov/kml/qpf/QPF120hr_Day1-5_latest.kml',
		"Day 1-7" => 'http://www.wpc.ncep.noaa.gov/kml/qpf/QPF168hr_Day1-7_latest.kml'
	);

	public function get_endpoint_urls() {
		$urls = array();
		foreach ($this->endpoints as $forecast => $url) {
			$urls[$forecast] = $url;
		}
		return $urls;
	}

	public function get_local_copy_filenames() {
		$filenames = array();
		foreach ($this->endpoints as $forecast => $url) {
			$filenames[$forecast] = LOCAL_KML_URL_PREFIX . $forecast . LOCAL_KML_URL_SUFFIX;
		}
		return $filenames;
	}

	public function get_local_filename() {
		return getcwd() . LOCAL_JSON_PATH . LOCAL_JSON_FILENAME;
	}
}

class endpointCopier {
	
	public function copy_endpoints($urls, $localCopies)
	{
		echo "<h2>Retrieving ...</h2><dl>";
		try {
			foreach ($urls as $forecast => $url) {
			echo "<dt>" . $url . "</dt>";
			echo "<dt>" . $localCopies[$forecast] . "</dt>";
				if (!copy($url, $localCopies[$forecast])) {
					echo("<dd>Failure</dd>");
				} else {
					echo("<dd>Success</dd>");
				}
			}
		} catch(Exception $e) {
			log('Caught exception: ', $e->getMessage());
		}
		echo "</dl>";
	}
}

class xmlGetObject {
	public function get($url) {
	    $fileContents = file_get_contents($url);
            $fileContents = str_replace(array("\n", "\r", "\t"), '', $fileContents);
            $fileContents = trim(str_replace('"', "'", $fileContents));
            $simpleXml 	  = simplexml_load_string($fileContents);
            $xobject = new SimpleXMLElement($fileContents);
            echo $xobject->asXML();
            return $simpleXml;
	}
}

class translateEndpoints {
	public function combine($sources) {
		$xml        = new xmlGetObject();
		$translated = array();

		foreach ($sources as $key => $value) {
			$translated[$key] = $xml->get($value);
		}

		return json_encode($translated);
	}
}

$config     = new endpointConfig();
$locals     = $config->get_local_copy_filenames();
$copy       = new endpointCopier();
$translator = new translateEndpoints();
$xml    = new xmlGetObject;
//$xml_element = new SimpleXMLElement($xml->get($locals['2 day']));
//echo $xml_element->asXML();

$copy->copy_endpoints($config->get_endpoint_urls(), $locals);

//$translated = $translator->combine($locals);

//$jsonFile = fopen($config->get_local_filename(), "w") or die("Unable to open file!");
//fwrite($jsonFile, $translated);
//fclose($jsonFile);

//echo php_sapi_name();
//print_r($translated);
//print_r(json_encode($xml->get($locals['Hannibal, MO'])));



//print_r($test->get_endpoint_urls());
?>
